:RETRY
@echo off
@set command=e
@set DEVICE_PID=0000
@set DONGLE_PID=0000
@set DEVICE_USAGE_PAGE=0000
@set DONGLE_USAGE_PAGE=0000

for /f "tokens=1,2 delims==" %%a in (config.ini) do (
	if %%a==device_usb_pid set dev_pid=%%b
	if %%a==device_usage_page set dev_usage_page=%%b
	if %%a==unify_dongle_pid set dng_pid=%%b
	if %%a==unify_dongle_usage_page set dng_usage_page=%%b
)

@if "%dev_pid%" EQU "" (
	@echo device_usb_pid NOT DEFINED
	@goto EXIT
)
@if "%dev_usage_page%" EQU "" (
	@echo device_usage_page NOT DEFINED
	@goto EXIT
)
@if "%dng_pid%" EQU "" (
	@echo dongle_pid NOT DEFINED
	@goto EXIT
)
@if "%dng_usage_page%" EQU "" (
	@echo dongle_usage_page NOT DEFINED
	@goto EXIT
)

@if "%dev_pid%" NEQ "%DEVICE_PID%" (set DEVICE_PID=%dev_pid%)
@if "%dev_usage_page%" NEQ "%DEVICE_USAGE_PAGE%" (set DEVICE_USAGE_PAGE=%dev_usage_page%)
@if "%dng_pid%" NEQ "%DONGLE_PID%" (set DONGLE_PID=%dng_pid%)
@if "%dng_usage_page%" NEQ "%DONGLE_USAGE_PAGE%" (set DONGLE_USAGE_PAGE=%dng_usage_page%)

@echo DEVICE_PID : %DEVICE_PID%
@echo DEVICE_USAGE_PAGE : %DEVICE_USAGE_PAGE%
@echo DONGLE_PID : %DONGLE_PID%
@echo DONGLE_USAGE_PAGE : %DONGLE_USAGE_PAGE%


:VERIFY_SERIAL_NUMBER
@echo --------------------- Factory Mode - Enable Factory Mode for device ----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    00    D3 A5    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Enable %DEVICE_NAME% Factory Mode.


@echo --------------------- Factory Mode - Enable Factory Mode for dongle ----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    00    D3 A5    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Enable Dongle Factory Mode.


@echo --------------------- Factory Mode - Get Identification Serial Number from device ---------------------
REM               PID                              | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%   FA    0E    01 00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto ERROR
@type temp.txt | findstr /n /c:"hid read" > temp2.txt
@del temp.txt
@set /p res=<temp2.txt && del temp2.txt

@for /f "tokens=8,8 delims=, " %%a in ("%res%") do (
   @set data0=%%a
)
@for /f "tokens=9,9 delims=, " %%a in ("%res%") do (
   @set data1=%%a
)
@for /f "tokens=10,10 delims=, " %%a in ("%res%") do (
   @set data2=%%a
)
@for /f "tokens=11,11 delims=, " %%a in ("%res%") do (
   @set data3=%%a
)
@for /f "tokens=12,12 delims=, " %%a in ("%res%") do (
   @set data4=%%a
)
@for /f "tokens=13,13 delims=, " %%a in ("%res%") do (
   @set data5=%%a
)
@for /f "tokens=14,14 delims=, " %%a in ("%res%") do (
   @set data6=%%a
)
@for /f "tokens=15,15 delims=, " %%a in ("%res%") do (
   @set data7=%%a
)
@for /f "tokens=16,16 delims=, " %%a in ("%res%") do (
   @set data8=%%a
)
@for /f "tokens=17,17 delims=, " %%a in ("%res%") do (
   @set data9=%%a
)
@for /f "tokens=18,18 delims=, " %%a in ("%res%") do (
   @set data10=%%a
)
@for /f "tokens=19,19 delims=, " %%a in ("%res%") do (
   @set data11=%%a
)
@for /f "tokens=20,20 delims=, " %%a in ("%res%") do (
   @set data12=%%a
)
@for /f "tokens=21,21 delims=, " %%a in ("%res%") do (
   @set data13=%%a
)

@echo -------------------------------
@set ISN=%data0%%data1%%data2%%data3%%data4%%data5%%data6%%data7%%data8%%data9%%data10%%data11%
@setlocal enabledelayedexpansion
@echo Serial Number(Hex): !ISN!
@echo !ISN!> temp.hex
@call certutil -decodehex temp.hex str.txt >nul
@set /p str=<str.txt
@( del temp.hex & del str.txt )>nul
@echo Serial Number(Str): !str!
@endlocal

@echo --------------------- Factory Mode - Set Sequential Serial Number to Dongle ---------------------
:SET_SERIAL_NUMBER
@set RES=
rem @set STR=4E394D504744353339353331
@set STR=%ISN%
@set SN_ORI=%STR%
REM transfer to lowercase
for %%i in (a b c d e f g h i j k l m n o p q r s t u v w x y z) do call set SN_ORI=%%SN_ORI:%%i=%%i%%


SETLOCAL ENABLEDELAYEDEXPANSION
REM Split STR by N characters
SET "N=2"
:LOOP1
SET "RES=%RES%!STR:~0,%N%! "
SET "STR=!STR:~%N%!"
IF DEFINED STR GOTO LOOP1
@ECHO %RES:~0,-1%

REM               PID                              | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%   FA    0E    03 00   %RES:~0,-1%



@echo --------------------- Factory Mode - Get Sequential Serial Number from Dongle ---------------------
REM                   PID                           | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%    FA    0E    04 00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@type temp.txt | findstr /n /c:"hid read" > temp2.txt
@del temp.txt
@set /p res=<temp2.txt && del temp2.txt

@for /f "tokens=8,8 delims=, " %%a in ("%res%") do (
   @set data0=%%a
)
@for /f "tokens=9,9 delims=, " %%a in ("%res%") do (
   @set data1=%%a
)
@for /f "tokens=10,10 delims=, " %%a in ("%res%") do (
   @set data2=%%a
)
@for /f "tokens=11,11 delims=, " %%a in ("%res%") do (
   @set data3=%%a
)
@for /f "tokens=12,12 delims=, " %%a in ("%res%") do (
   @set data4=%%a
)
@for /f "tokens=13,13 delims=, " %%a in ("%res%") do (
   @set data5=%%a
)
@for /f "tokens=14,14 delims=, " %%a in ("%res%") do (
   @set data6=%%a
)
@for /f "tokens=15,15 delims=, " %%a in ("%res%") do (
   @set data7=%%a
)
@for /f "tokens=16,16 delims=, " %%a in ("%res%") do (
   @set data8=%%a
)
@for /f "tokens=17,17 delims=, " %%a in ("%res%") do (
   @set data9=%%a
)
@for /f "tokens=18,18 delims=, " %%a in ("%res%") do (
   @set data10=%%a
)
@for /f "tokens=19,19 delims=, " %%a in ("%res%") do (
   @set data11=%%a
)
@for /f "tokens=20,20 delims=, " %%a in ("%res%") do (
   @set data12=%%a
)
@for /f "tokens=21,21 delims=, " %%a in ("%res%") do (
   @set data13=%%a
)

@echo -------------------------------
@set SN=%data0%%data1%%data2%%data3%%data4%%data5%%data6%%data7%%data8%%data9%%data10%%data11%
@setlocal enabledelayedexpansion
@echo Serial Number(Hex): !SN!
@echo !SN!> temp.hex
@call certutil -decodehex temp.hex str.txt >nul
@set /p str=<str.txt
@( del temp.hex & del str.txt )>nul
@echo Serial Number(Str): !str!

:CHECK_DONGLE_SSN
@echo --------------------- Factory Mode - Confirm Identification serial number ---------------------
if %ISN% == %SN% (
	color 02
	@echo Confirm Dongle SSN and Dongle SSN pass !
) else (
	color 04
	@echo Confirm Dongle SSN and Dongle SSN fail !
)

@endlocal

:LEAVE_RF_MODE
@echo --------------------- Factory Mode - Disable Factory Mode --------------------
REM               PID                              | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%   FA    00    00 00    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Disable %DEVICE_NAME% Factory Mode.

REM               PID                              | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE%   FA    00    00 00    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Disable Dongle Factory Mode.


:SET_DEVICE_SSN
@echo --------------------- Factory Mode - Enable Factory Mode for device ----------------------
REM               PID                               | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    00    D3 A5    00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@del temp.txt
@echo  -Enable %DEVICE_NAME% Factory Mode.

@echo --------------------- Factory Mode - Set Sequential Serial Number to Device ---------------------

setlocal enabledelayedexpansion

REM 使用 PowerShell 獲取當前日期和時間，包括毫秒
for /f "delims=" %%a in ('powershell Get-Date -Format "{yyyyMMddHHmmssfff}"') do set datetime=%%a

REM 提取年、月、日、時、分、秒和毫秒
set "year=52" 
set "month=!datetime:~4,2!"
set "day1=3!datetime:~6,1!"
set "day2=3!datetime:~7,1!"
set "hour1=3!datetime:~8,1!"
set "hour2=3!datetime:~9,1!"
set "minute1=3!datetime:~10,1!"
set "minute2=3!datetime:~11,1!"
set "second1=3!datetime:~12,1!"
set "second2=3!datetime:~13,1!"
set "millisecond1=3!datetime:~14,1!"
set "millisecond2=3!datetime:~15,1!"

for /f %%a in ('powershell -Command "$month = [Convert]::ToByte('%month%'); '{0:X}' -f $month"') do set hex_month=%%a


if "!hex_month!" EQU "A" (
    set "hex_month=41"
    set "flag=1"
) else if "!hex_month!" EQU "B" (
    set "hex_month=42"
    set "flag=1"
) else if "!hex_month!" EQU "C" (
    set "hex_month=43"
    set "flag=1"
)

if "!flag!" NEQ "1" (
    set "hex_month=3!datetime:~5,1!"
)

echo SSN : %year% %hex_month% %day1% %day2% %hour1% %hour2% %minute1% %minute2% %second1% %second2% %millisecond1% %millisecond2%
@set SSN=%year% %hex_month% %day1% %day2% %hour1% %hour2% %minute1% %minute2% %second1% %second2% %millisecond1% %millisecond2%


REM               PID                              | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%   FA    0E    03 00   %SSN%


@echo --------------------- Factory Mode - Get Sequential Serial Number from Device ---------------------
REM                   PID                           | CMD | Key | Index  | Data...
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE%    FA    0E    04 00 > temp.txt
@type temp.txt | findstr /n /c:"hid read" || goto FAC_ERROR
@type temp.txt | findstr /n /c:"hid read" > temp2.txt
@del temp.txt
@set /p res=<temp2.txt && del temp2.txt

@for /f "tokens=8,8 delims=, " %%a in ("%res%") do (
   @set data0=%%a
)
@for /f "tokens=9,9 delims=, " %%a in ("%res%") do (
   @set data1=%%a
)
@for /f "tokens=10,10 delims=, " %%a in ("%res%") do (
   @set data2=%%a
)
@for /f "tokens=11,11 delims=, " %%a in ("%res%") do (
   @set data3=%%a
)
@for /f "tokens=12,12 delims=, " %%a in ("%res%") do (
   @set data4=%%a
)
@for /f "tokens=13,13 delims=, " %%a in ("%res%") do (
   @set data5=%%a
)
@for /f "tokens=14,14 delims=, " %%a in ("%res%") do (
   @set data6=%%a
)
@for /f "tokens=15,15 delims=, " %%a in ("%res%") do (
   @set data7=%%a
)
@for /f "tokens=16,16 delims=, " %%a in ("%res%") do (
   @set data8=%%a
)
@for /f "tokens=17,17 delims=, " %%a in ("%res%") do (
   @set data9=%%a
)
@for /f "tokens=18,18 delims=, " %%a in ("%res%") do (
   @set data10=%%a
)
@for /f "tokens=19,19 delims=, " %%a in ("%res%") do (
   @set data11=%%a
)
@for /f "tokens=20,20 delims=, " %%a in ("%res%") do (
   @set data12=%%a
)
@for /f "tokens=21,21 delims=, " %%a in ("%res%") do (
   @set data13=%%a
)

@echo -------------------------------
@set SN=%data0%%data1%%data2%%data3%%data4%%data5%%data6%%data7%%data8%%data9%%data10%%data11%
@setlocal enabledelayedexpansion
@echo Serial Number(Hex): !SN!
@echo !SN!> temp.hex
@call certutil -decodehex temp.hex str.txt >nul
@set /p str=<str.txt
@( del temp.hex & del str.txt )>nul
@echo Serial Number(Str): !str!

timeout /t 3
@echo --------------------- Reset Device ---------------------
usb_hid_cmd.exe r %DEVICE_PID% %DEVICE_USAGE_PAGE% B0 00 00 00 72 65 73 65 74

timeout /t 3
@echo --------------------- Reset Dongle ---------------------
usb_hid_cmd.exe r %DONGLE_PID% %DONGLE_USAGE_PAGE% B0 00 00 00 72 65 73 65 74

timeout /t 10